package uoc.project.myentities.core;

import java.sql.SQLException;

import uoc.project.myentities.exceptions.ResourceNotFoundException;

public interface CoreService {

	/**
	 * Load entities from a remote system
	 * @param entityType
	 * @param application
	 * @throws SQLException
	 * @throws ResourceNotFoundException
	 */
	void load(String entityType, String application) throws SQLException, ResourceNotFoundException;

	/**
	 * Deletes an application
	 * @param applicationId
	 */
	void deleteApplication(long applicationId);

	/**
	 * Add an entity to be created on a remote system
	 * @param entity
	 * @throws SQLException
	 */
	void add(Object entity) throws SQLException;
	
}
