package uoc.project.myentities.core.connectors;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

@Component
public class MySQLConnector {
	
	private static final Logger log = LoggerFactory.getLogger(MySQLConnector.class);

	/**
	 * Opens a SQL connection
	 * @param host
	 * @param user
	 * @param password
	 * @return
	 */
	public Connection getConnection(String host, String user, String password) {
		log.info("Connecting to... " + host);
		Connection conn = null;
		try {
			conn = DriverManager.getConnection("jdbc:mysql://"+host, user, password);
		} catch (SQLException e) {
			log.error(e.getMessage());
		}
		return conn;
	}
	
}
