package uoc.project.myentities.entities;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import lombok.Data;

@Data
@Entity(name = "account")
public class AccountEntity implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 9121476680377829293L;

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "acc_id")
    private long id;

    @Column(name = "acc_ext_id")
    private long externalId;
    
    @Column(name = "acc_name")
    private String name;
    
    @Column(name = "acc_desc")
    private String description;

    @ManyToOne
    @JoinColumn(name = "acc_usr_id")
    private UserEntity user;
    
    @ManyToOne
    @JoinColumn(name = "acc_app_id")
    private ApplicationEntity application;
    
}
