package uoc.project.myentities.entities;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;

import lombok.Data;
import uoc.project.myentities.enums.TypeEnum;

@Data
@Entity(name = "application")
public class ApplicationEntity implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8050182451650411192L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "app_id")
	private long id;

	@Column(name = "app_name")
	private String name;

	@Column(name = "app_desc")
	private String description;

	@Column(name = "app_type")
	@Enumerated(EnumType.STRING)
	private TypeEnum type;

	@Column(name = "app_host")
	private String host;

	@Column(name = "app_user")
	private String user;

	@Column(name = "app_password")
	private String password;

	@OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
	@JoinColumn(name="app_query_app_id", referencedColumnName="app_id")
	private List<ApplicationQueryEntity> queries;
}
