package uoc.project.myentities.entities;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import lombok.Data;

@Data
@Entity(name = "perm_acc")
public class PermissionAccountEntity implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = -79192991293905871L;

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "perm_acc_id")
    private long id;

    @ManyToOne
    @JoinColumn(name = "perm_acc_acc_id")
    private AccountEntity account;
    
    @ManyToOne
    @JoinColumn(name = "perm_acc_perm_id")
    private PermissionEntity permission;
    
    @Temporal(TemporalType.DATE)
    @Column(name = "perm_acc_startdate")
    private Date startDate;
    
    @Temporal(TemporalType.DATE)
    @Column(name = "perm_acc_enddate")
    private Date endDate;
    
    
}
