package uoc.project.myentities.entities;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import lombok.Data;

@Data
@Entity(name = "permission")
public class PermissionEntity implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 9003672250322859546L;

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "perm_id")
    private long id;
    
    @Column(name = "perm_ext_id")
    private long externalId;

    @Column(name = "perm_name")
    private String name;

    @Column(name = "perm_desc")
    private String description;
    
    @ManyToOne
    @JoinColumn(name = "perm_app_id")
    private ApplicationEntity application;
    
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "id", orphanRemoval = true)
    private List<PermissionAccountEntity> permissionsAccount;
    
}
