package uoc.project.myentities.entities;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import lombok.Data;
import uoc.project.myentities.enums.StatusEnum;

@Data
@Entity(name = "user")
public class UserEntity implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = -4751612264593963097L;

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "usr_id")
    private long id;

    @Column(name = "usr_name")
    private String userName;

    @Column(name = "usr_firstname")
    private String firstName;

    @Column(name = "usr_lastname")
    private String lastName;
    
    @Column(name = "usr_password")
    private String password;

    @Temporal(TemporalType.DATE)
    @Column(name = "usr_birth")
    private Date birthDate;

    @Column(name = "usr_status")
    @Enumerated(EnumType.STRING)
    private StatusEnum status;
    
}
