package uoc.project.myentities.mapper;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import uoc.project.myentities.entities.AccountEntity;
import uoc.project.myentities.model.Account;

@Component
public class AccountMapper {

	@Autowired
	private UserMapper userMapper;

	@Autowired
	private ApplicationMapper applicationMapper;

	/**
	 * Converts a @Account into a @AccountEntity object
	 * @param accountEntity
	 * @return
	 */
	public AccountEntity accountToAccountEntity(Account account) {
		AccountEntity accountEntity = new AccountEntity();
		accountEntity.setId(account.getId());
		accountEntity.setExternalId(account.getExternalId());
		accountEntity.setName(account.getName());
		accountEntity.setDescription(account.getDescription());
		accountEntity.setUser(userMapper.userToUserEntity(account.getUser()));
		accountEntity.setApplication(applicationMapper.applicationToApplicationEntity(account.getApplication()));
		return accountEntity;
	}

	/**
	 * Converts a @AccountEntity into a @Account object
	 * @param accountEntity
	 * @return
	 */
	public Account accountEntityToAccount(AccountEntity accountEntity) {
		Account account = new Account();
		account.setId(accountEntity.getId());
		account.setExternalId(accountEntity.getExternalId());
		account.setName(accountEntity.getName());
		account.setDescription(accountEntity.getDescription());
		account.setUser(userMapper.userEntityToUser(accountEntity.getUser()));
		account.setApplication(applicationMapper.applicationEntityToApplication(accountEntity.getApplication()));
		return account;
	}
}
