package uoc.project.myentities.mapper;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import uoc.project.myentities.entities.PermissionEntity;
import uoc.project.myentities.model.Permission;

@Component
public class PermissionMapper {

	@Autowired
	private ApplicationMapper applicationMapper;
	
	/**
	 * Converts a @Permission into a @PermissionEntity object
	 * @param permission
	 * @return
	 */
	public PermissionEntity permissionToPermissionEntity(Permission permission) {
		PermissionEntity permissionEntity = new PermissionEntity();
		permissionEntity.setId(permission.getId());
		permissionEntity.setExternalId(permission.getExternalId());
		permissionEntity.setName(permission.getName());
		permissionEntity.setDescription(permission.getDescription());
		permissionEntity.setApplication(applicationMapper.applicationToApplicationEntity(permission.getApplication()));
		return permissionEntity;
	}

	/**
	 * Converts a @PermissionEntity into a @Permission object
	 * @param permissionEntity
	 * @return
	 */
	public Permission permissionEntityToPermission(PermissionEntity permissionEntity) {
		Permission permission = new Permission();
		permission.setId(permissionEntity.getId());
		permission.setExternalId(permissionEntity.getExternalId());
		permission.setName(permissionEntity.getName());
		permission.setDescription(permissionEntity.getDescription());
		permission.setApplication(applicationMapper.applicationEntityToApplication(permissionEntity.getApplication()));
		return permission;
	}
}
