package uoc.project.myentities.mapper;

import org.springframework.stereotype.Component;

import uoc.project.myentities.entities.ApplicationQueryEntity;
import uoc.project.myentities.model.ApplicationQuery;

@Component
public class QueryMapper {

	/**
	 * Converts a @ApplicationQuery into a @ApplicationQueryEntity object
	 * @param query
	 * @return
	 */
	public ApplicationQueryEntity appQueryToAppQueryEntity(ApplicationQuery query) {
		ApplicationQueryEntity queryEntity = new ApplicationQueryEntity();
		queryEntity.setId(query.getId());
		queryEntity.setApplication(query.getApplication());
		queryEntity.setEntity(query.getEntity());
		queryEntity.setAction(query.getAction());
		queryEntity.setQuery(query.getQuery());
		return queryEntity;
	}

	/**
	 * Converts a @ApplicationQueryEntity into a @ApplicationQuery object
	 * @param appQuery
	 * @return
	 */
	public ApplicationQuery appQueryEntityToAppQuery(ApplicationQueryEntity appQuery) {
		ApplicationQuery query = new ApplicationQuery();
		query.setId(appQuery.getId());
		query.setApplication(appQuery.getApplication());
		query.setEntity(appQuery.getEntity());
		query.setAction(appQuery.getAction());
		query.setQuery(appQuery.getQuery());
		return query;
	}
}
