package uoc.project.myentities.mapper;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import uoc.project.myentities.entities.UserEntity;
import uoc.project.myentities.model.User;
import uoc.project.myentities.utils.DateUtils;

@Component
public class UserMapper {

	@Autowired
	private DateUtils utils;

	/**
	 * Converts a @User into a @UserEntity object
	 * @param user
	 * @return
	 */
	public UserEntity userToUserEntity(User user) {
		UserEntity userEntity = new UserEntity();
		userEntity.setId(user.getId());
		userEntity.setUserName(user.getUserName());
		userEntity.setPassword(user.getPassword());
		userEntity.setFirstName(user.getFirstName());
		userEntity.setLastName(user.getLastName());
		userEntity.setBirthDate((Date) utils.formatDate(user.getBirthDate()));
		userEntity.setStatus(user.getStatus());
		return userEntity;
	}

	/**
	 * Converts a @UserEntity into a @User object
	 * @param userEntity
	 * @return
	 */
	public User userEntityToUser(UserEntity userEntity) {
		User user = new User();
		user.setId(userEntity.getId());
		user.setUserName(userEntity.getUserName());
		user.setPassword(userEntity.getPassword());
		user.setFirstName(userEntity.getFirstName());
		user.setLastName(userEntity.getLastName());
		user.setBirthDate((String) utils.formatDate(userEntity.getBirthDate()));
		user.setStatus(userEntity.getStatus());
		return user;
	}
}
