package uoc.project.myentities.service;

import java.util.Collection;

import uoc.project.myentities.entities.ApplicationEntity;
import uoc.project.myentities.exceptions.ResourceNotFoundException;

public interface ApplicationService {

	/**
	 * Get all @ApplicationEntity
	 * @return
	 * @throws ResourceNotFoundException
	 */
	Collection<ApplicationEntity> getAll() throws ResourceNotFoundException;

	/**
	 * Get an @ApplicationEntity by its id
	 * @param id
	 * @return
	 * @throws ResourceNotFoundException
	 */
	ApplicationEntity getOne(long id) throws ResourceNotFoundException;

	/**
	 * Add a new @ApplicationEntity
	 * @param user
	 */
	void add(ApplicationEntity user);

	/**
	 * Update an existing @ApplicationEntity
	 * @param user
	 */
	void update(ApplicationEntity user);

	/**
	 * Delete an existing @ApplicationEntity by its id
	 * @param id
	 * @throws ResourceNotFoundException
	 */
	void delete(long id) throws ResourceNotFoundException;

}
