package uoc.project.myentities.service;

import java.util.Collection;

import uoc.project.myentities.entities.PermissionAccountEntity;
import uoc.project.myentities.entities.PermissionEntity;
import uoc.project.myentities.exceptions.ResourceNotFoundException;

public interface PermissionService {

	/**
	 * Gets all @PermissionEntity
	 * @return
	 * @throws ResourceNotFoundException
	 */
	Collection<PermissionEntity> getAll() throws ResourceNotFoundException;

	/**
	 * Gets a @PermissionEntity by its id
	 * @param id
	 * @return
	 * @throws ResourceNotFoundException
	 */
	PermissionEntity getOne(long id) throws ResourceNotFoundException;
	
	/**
	 * Gets a @PermissionEntity by its externalId
	 * @param externalId
	 * @return
	 * @throws ResourceNotFoundException
	 */
	PermissionEntity getByExternalId(long externalId) throws ResourceNotFoundException;

	/**
	 * Add a new @PermissionEntity
	 * @param permission
	 */
	void add(PermissionEntity permission);
	
	/**
	 * Get permissions from an @AccountEntity by its id
	 * @param accountId
	 * @return
	 * @throws ResourceNotFoundException
	 */
	Collection<PermissionAccountEntity> getPermissionsByAccount(long accountId) throws ResourceNotFoundException;
	
	/**
	 * Deletes permissions from an @AccountEntity by its id
	 * @param permissionAccount
	 * @throws ResourceNotFoundException
	 */
	void deletePermissionAccount(long permissionAccount) throws ResourceNotFoundException;
}
