package uoc.project.myentities.service;

import java.util.Collection;

import uoc.project.myentities.entities.UserEntity;
import uoc.project.myentities.exceptions.ResourceNotFoundException;

public interface UserService {

	/**
	 * Get all @UserEntity
	 * @return
	 * @throws ResourceNotFoundException
	 */
	Collection<UserEntity> getAll() throws ResourceNotFoundException;

	/**
	 * Gets an existing @UserEntity by its id
	 * @param id
	 * @return
	 * @throws ResourceNotFoundException
	 */
	UserEntity getOne(long id) throws ResourceNotFoundException;

	/**
	 * Inserts a new @UserEntity
	 * @param user
	 * @return
	 */
	UserEntity add(UserEntity user);

	/**
	 * Updates an existing @UserEntity
	 * @param user
	 * @return
	 */
	UserEntity update(UserEntity user);

	/**
	 * Delete an existing @UserEntity by its id
	 * @param id
	 * @throws ResourceNotFoundException
	 */
	void delete(long id) throws ResourceNotFoundException;

}
