package uoc.project.myentities.service.impl;

import java.util.Collection;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import uoc.project.myentities.entities.ApplicationEntity;
import uoc.project.myentities.entities.ApplicationQueryEntity;
import uoc.project.myentities.exceptions.ResourceNotFoundException;
import uoc.project.myentities.repository.ApplicationQueryRepository;
import uoc.project.myentities.repository.ApplicationRepository;
import uoc.project.myentities.service.ApplicationService;

@Service
public class ApplicationServiceImpl implements ApplicationService {

	@Autowired
	private ApplicationRepository applicationRepository;
	
	@Autowired
	private ApplicationQueryRepository applicationQueryRepository;

	@Override
	public Collection<ApplicationEntity> getAll() throws ResourceNotFoundException {
		List<ApplicationEntity> entities = applicationRepository.findAll();
		if (entities.isEmpty()) {
			throw new ResourceNotFoundException("", "", "");
		}
		return entities;
	}

	@Override
	public ApplicationEntity getOne(long id) throws ResourceNotFoundException {
		ApplicationEntity entity = applicationRepository.getOne(id);
		if (entity == null) {
			throw new ResourceNotFoundException("", "", "");
		}
		return entity;
	}

	@Override
	public void add(ApplicationEntity entity) {
		applicationRepository.save(entity);
	}

	@Override
	public void update(ApplicationEntity entity) {
		applicationRepository.save(entity);
	}

	@Override
	public void delete(long id) throws ResourceNotFoundException {
		ApplicationEntity entity = applicationRepository.getOne(id);
		if (entity == null) {
			throw new ResourceNotFoundException("", "", "");
		}
		
		for(ApplicationQueryEntity query : entity.getQueries()) {
			applicationQueryRepository.delete(query);
		}
		
		for(ApplicationQueryEntity query : entity.getQueries()) {
			applicationQueryRepository.delete(query);
		}
		
		applicationRepository.delete(entity);
	}
}
