package uoc.project.myentities.service.impl;

import java.util.Collection;
import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import uoc.project.myentities.entities.PermissionAccountEntity;
import uoc.project.myentities.entities.PermissionEntity;
import uoc.project.myentities.exceptions.ResourceNotFoundException;
import uoc.project.myentities.repository.PermissionAccountRepository;
import uoc.project.myentities.repository.PermissionRepository;
import uoc.project.myentities.service.PermissionService;

@Service
public class PermissionServiceImpl implements PermissionService {

	@Autowired
	private PermissionRepository permissionRepository;
	
	@Autowired
	private PermissionAccountRepository permissionAccountRepository;

	@Override
	public Collection<PermissionEntity> getAll() throws ResourceNotFoundException {
		List<PermissionEntity> entities = permissionRepository.findAll();
		if (entities.isEmpty()) {
			throw new ResourceNotFoundException("", "", "");
		}
		return entities;
	}

	@Override
	public PermissionEntity getOne(long id) throws ResourceNotFoundException {
		PermissionEntity entity = permissionRepository.getOne(id);
		if (entity == null) {
			throw new ResourceNotFoundException("", "", "");
		}
		return entity;
	}
	
	@Override
	public PermissionEntity getByExternalId(long externalId) throws ResourceNotFoundException {
		PermissionEntity example = new PermissionEntity();
		example.setExternalId(externalId);
		
		Optional<PermissionEntity> entity = permissionRepository.findOne(Example.of(example));
		if (!entity.isPresent()) {
			return null;
		}
		return entity.get();
	}

	@Override
	public void add(PermissionEntity permission) {
		permissionRepository.save(permission);
		
	}

	@Override
	public  Collection<PermissionAccountEntity> getPermissionsByAccount(long accountId) throws ResourceNotFoundException {
		return permissionAccountRepository.findPermissionsByAccount(accountId);
	}

	@Override
	public void deletePermissionAccount(long id) throws ResourceNotFoundException {
		PermissionAccountEntity entity = permissionAccountRepository.getOne(id);
		if (entity == null) {
			throw new ResourceNotFoundException("", "", "");
		}
		permissionAccountRepository.delete(entity);
	}
	
}
