package uoc.project.myentities.utils;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

@Component
public class DateUtils {

	private static final Logger log = LoggerFactory.getLogger(DateUtils.class);

	private SimpleDateFormat sf = new SimpleDateFormat("dd/MM/yyyy");

	/**
	 * Formats a date depending if it's a @String or a @Date
	 * @param birthDate
	 * @return
	 */
	public Object formatDate(Object birthDate) {
		try {
			if (birthDate instanceof String) {
				return sf.parse((String) birthDate);
			}

			if (birthDate instanceof Date) {
				return sf.format((Date) birthDate);
			}
		} catch (Exception e) {
			log.error(e.getMessage());
		}
		return null;
	}

}
