import Vue from 'vue'
import VueRouter from 'vue-router'
import Dashboard from '../views/Dashboard.vue'
import Users from '../views/Users.vue'
import Accounts from '../views/Accounts.vue'
import Permissions from '../views/Permissions.vue'
import Applications from '../views/Applications.vue'
import Login from '../views/Login.vue'

Vue.use(VueRouter)

const routes = [
    {
        path: '/',
        name: 'Dashboard',
        component: Dashboard
      },
      {
        path: '/login',
        name: 'Login',
        component: Login
      },
      {
        path: '/users',
        name: 'Users',
        component: Users
      },
      {
        path: '/accounts',
        name: 'Accounts',
        component: Accounts
      },
      {
        path: '/permissions',
        name: 'Permissions',
        component: Permissions
      },
      {
        path: '/applications',
        name: 'Applications',
        component: Applications
      }
]

export const router = new VueRouter({
    mode: 'history',
    base: process.env.BASE_URL,
    routes
});

router.beforeEach((to, from, next) => {
    // redirect to login page if not logged in and trying to access a restricted page
    const publicPages = ['/login'];
    const authRequired = !publicPages.includes(to.path);
    const loggedIn = localStorage.getItem('user');

    if (authRequired && !loggedIn) {
        return next('/login');
    }

    next();
})