import Vue from 'vue'
import Vuex from 'vuex'
import vuetify from './plugins/vuetify'
import VueResource from 'vue-resource';
import Axios from 'axios'
import App from './App.vue'
import { store } from './_store';
import { router } from './_helpers';
import {authHeader} from './_helpers';

Axios.defaults.headers['Content-Type'] = 'application/json';
Axios.defaults.headers['Access-Control-Allow-Origin'] = '*';

Vue.prototype.$http = Axios;

// telling vue.js to use this package
Vue.use(VueResource);

Vue.http.interceptors.push(function(request,next){
  const token = authHeader();
  request.headers.set('Authorization', token);
  next();
})

Vue.config.productionTip = false;

Vue.use(Vuex);

new Vue({
  router,
  vuetify,
  store,
  render: h => h(App)
}).$mount('#app')
